Module java.compiler
Package javax.lang.model.util

# Class ElementKindVisitor7<R,​P>

java.lang.Object
javax.lang.model.util.AbstractElementVisitor6<R,​P>
javax.lang.model.util.SimpleElementVisitor6<R,​P>
javax.lang.model.util.ElementKindVisitor6<R,​P>
javax.lang.model.util.ElementKindVisitor7<R,​P>

Type Parameters:
  `R` - the return type of this visitor's methods. Use `Void` for visitors that do not need to return results.
  `P` - the type of the additional parameter to this visitor's methods. Use `Void` for visitors that do not need an additional parameter.

All Implemented Interfaces:
  `ElementVisitor<R,​P>`

Direct Known Subclasses:
  `ElementKindVisitor8`

    @SupportedSourceVersion(RELEASE_7)
    public class ElementKindVisitor7<R,​P>
    extends ElementKindVisitor6<R,​P>

A visitor of program elements based on their kind with default behavior appropriate for the `RELEASE_7` source version. For elements `Xyz` that may have more than one kind, the `visitXyz` methods in this class delegate to the `visitXyzAsKind` method corresponding to the first argument's kind. The `visitXyzAsKind` methods call `defaultAction`, passing their arguments to `defaultAction`'s corresponding parameters.

Methods in this class may be overridden subject to their general contract. Note that annotating methods in concrete subclasses with `@Override` will help ensure that methods are overridden as intended.

WARNING: The `ElementVisitor` interface implemented by this class may have methods added to it or the `ElementKind` `enum` used in this case may have constants added to it in the future to accommodate new, currently unknown, language structures added to future versions of the Java™ programming language. Therefore, methods whose names begin with `"visit"` may be added to this class in the future; to avoid incompatibilities, classes which extend this class should not declare any instance methods with names beginning with `"visit"`.

When such a new visit method is added, the default implementation in this class will be to call the `visitUnknown` method. A new abstract element kind visitor class will also be introduced to correspond to the new language level; this visitor will have different default behavior for the visit method in question. When the new visitor is introduced, all or portions of this visitor may be deprecated.

Since:
  1.7
See Also:
  `ElementKindVisitor6`, `ElementKindVisitor8`, `ElementKindVisitor9`

## Field Summary

### Fields declared in class javax.lang.model.util.SimpleElementVisitor6

`DEFAULT_VALUE`

## Constructor Summary

Constructors
Modifier | Constructor | Description
--- | --- | ---
`protected` | `ElementKindVisitor7()` | Deprecated. Release 7 is obsolete; update to a visitor for a newer release level.
`protected` | `ElementKindVisitor7​(R defaultValue)` | Deprecated. Release 7 is obsolete; update to a visitor for a newer release level.

## Method Summary

Modifier and Type | Method | Description
--- | --- | ---
`R` | `visitVariableAsResourceVariable​(VariableElement e, P p)` | Visits a `RESOURCE_VARIABLE` variable element.

### Methods declared in class javax.lang.model.util.ElementKindVisitor6

`visitExecutable, visitExecutableAsConstructor, visitExecutableAsInstanceInit, visitExecutableAsMethod, visitExecutableAsStaticInit, visitPackage, visitType, visitTypeAsAnnotationType, visitTypeAsClass, visitTypeAsEnum, visitTypeAsInterface, visitTypeParameter, visitVariable, visitVariableAsEnumConstant, visitVariableAsExceptionParameter, visitVariableAsField, visitVariableAsLocalVariable, visitVariableAsParameter`

### Methods declared in class javax.lang.model.util.SimpleElementVisitor6

`defaultAction`

### Methods declared in class javax.lang.model.util.AbstractElementVisitor6

`visit, visit, visitModule, visitUnknown`

### Methods declared in class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### ElementKindVisitor7

@Deprecated(since="12") protected ElementKindVisitor7()
Deprecated.
Release 7 is obsolete; update to a visitor for a newer release level.
Constructor for concrete subclasses; uses `null` for the default value.

### ElementKindVisitor7

@Deprecated(since="12") protected ElementKindVisitor7​(R defaultValue)
Deprecated.
Release 7 is obsolete; update to a visitor for a newer release level.
Constructor for concrete subclasses; uses the argument for the default value.

Parameters:
  `defaultValue` - the value to assign to `SimpleElementVisitor6.DEFAULT_VALUE`

## Method Details

### visitVariableAsResourceVariable

public R visitVariableAsResourceVariable​(VariableElement e, P p)
Visits a `RESOURCE_VARIABLE` variable element.

Overrides:
  `visitVariableAsResourceVariable` in class `ElementKindVisitor6<R,​P>`
Implementation Requirements:
  This implementation calls `defaultAction`.
Parameters:
  `e` - the element to visit
  `p` - a visitor-specified parameter
Returns:
  the result of `defaultAction`